/* quicksort--based on K&R's example in "The C Programming Language" */ 

/* reads some integers from standard input, quicksorts them and 
     prints them to standard output 
 */ 

{
int b[10000]; 
int inSize;

qsort (b,0,(inSize = getData(b)) - 1); 
printData(b,inSize);  



int getData(var int a[10000];)
  {int i,inStatus;

   i = 0;   
   inStatus = input("%d\n",a[i]); 
   while (inStatus != EOF && inStatus != 0)  
     {i = i + 1;
      inStatus = input("%d\n",a[i]); 
     } 
   return i; 
  } 



void printData(var int a[10000]; int size;)
  {int i;

   i = 0;
   while (i < size) 
     {output("%d\n",a[i]);  
      i = i + 1;
     } 
  } 



void qsort(var int v[10000]; int left,right;) 
  {int i,last;

   if (left >= right) 
      then 
      return;
   swap(v,left,(left+right)/2); 
   last = left;
   i = left + 1;
   while (i <=  right) 
     {if (v[i] < v[left]) 
         then 
         {last = last + 1;
          swap (v,last,i); 
         }
      i = i + 1;
     }
   swap(v,left,last); 
   qsort(v,left,last-1);
   qsort(v,last+1,right);
  }



void swap(var int v[10000]; int i,j;)
  {int temp;
   
   temp = v[i];
   v[i] = v[j];
   v[j] = temp;
  }


}
