extern int       yylex (YYSTYPE *,YYLTYPE *);
extern void      yyerror(YYLTYPE *,const char *);

/* from the lexer */
extern int       yyyinput(void);

/* used by lexer */
extern void      eat_comment(const char *end,int *yycolno,int *yylineno);
extern symbol    addYaccSymbolIfNew(YYLTYPE *,char *);
extern void      dumpYaccSymbolTable(void);
extern char     *addOxSymbolIfNew(symTable,YYLTYPE *,char *);
extern void      dumpOxSymbolTable(void);
extern bool      cmpYaccToOxSymbolTable(void);

/* used by parser */
extern symTable  g_SymbolTable(void);
extern void      newConst(YYLTYPE,symbol,int);
extern symbol    newOxConst(symTable,YYLTYPE,char *,int);
extern YYLTYPE   locSpan(YYLTYPE,YYLTYPE);
extern int       valOf(YYLTYPE,symbol);
extern int       oxValOf(symTable,YYLTYPE,char *);
extern void      newType(YYLTYPE,symbol,typeSpecT);
extern symbol    newOxType(symTable,YYLTYPE,char *,typeSpecT);
extern typeSpecT makeEnumType(YYLTYPE,enumListT);
extern typeSpecT makeSubrangeType(YYLTYPE,int,int);
extern typeSpecT typeOf(YYLTYPE,symbol);
extern typeSpecT oxTypeOf(symTable,YYLTYPE,char *);
extern enumListT newEnum(YYLTYPE,symbol);
extern enumListT newOxEnum(symTable,YYLTYPE,char *);
extern enumListT addToEnum(YYLTYPE,enumListT,symbol);
extern enumListT addToOxEnum(symTable,YYLTYPE,enumListT,char *);
