%{
#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "gram.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%token ICONST IDENT
%%
seq	:	
	|	seq	ICONST
	|	seq	IDENT
	;
%%
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...) {fprintf(stderr,"%s\n",s);}  
#else
void yyerror(const char *s) {fprintf(stderr,"%s\n",s);}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif
int main()
  {yyparse();}	
